package jais.communication;

import java.util.ArrayList;

/**
 * <p>Title: Event</p>
 * <p>Description: From this class the 4 parser classes inherit the arraylist m_objects where the infos of the parsed server-message are stored later and the string m_message which contains the unparsed server infos</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * @author Oliver Beck
 */
public abstract class Event
{
  protected ArrayList m_objects;
  protected String m_message;

  /**
   * In this method the unparsed message is delivered
   * @param f_message contains unparsed string
   * @roseuid 3CEB63BA034E
   */
  public Event(String f_message)
  {
    m_message=f_message;
  }

  /**
   * This method delivers the parsed message as objects in form of a arraylist
   * @return java.util.ArrayList
   * @roseuid 3CEA8ADC007E
   */
  public ArrayList getObjects()
  {
    return m_objects;
  }

  /**
   * @param f_message
   * @roseuid 3CEA8B7F0032
   */
  public abstract void parseData();
}