package jais.communication;


/**
 *
 * <p>Title: PlayerStuffInterface</p>
 * <p>Description: This interface provides the player the needed methods to send data
 * messages to server in th needed format.</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p> </p>
 * @author Raul Zanzinger
 *
 */
public interface PlayerStuffInterface
{
  /**
   * This method provides the possibility to send to the server for the goalie
   * the cath command
   *
   * @roseuid 3CEA1B0403E4
   *
   * @param f_direction
   *
   * @throws xCommunication
   */
  public void catchBall(double f_direction) throws xCommunication;


  /**
   * This method provides the possibility to send to the server dash
   * commands.
   *
   * @roseuid 3CEA1AF4021F
   *
   * @param f_dashPower
   *
   * @throws xCommunication
   */
  public void dash(double f_dashPower) throws xCommunication;


  /**
   * This method provides the possibility to send to the server kick command.
   *
   * @roseuid 3CEA1AFB00D4
   *
   * @param f_kickPower
   * @param f_kickAngel
   *
   * @throws xCommunication
   */
  public void kick(double f_kickPower, double f_kickAngel) throws xCommunication;


  /**
   * This method provides the possibility to send to the server turn neck command
   *
   * @roseuid 3CEA1AEB0103
   *
   * @param f_turnNeckAngel
   *
   * @throws xCommunication
   */
  public void turnNeck(double f_turnNeckAngel) throws xCommunication;


  /**
   * This method provides the possibility to send to the server move to (x,y)
   * command for befor kick off playmode.
   *
   * @roseuid 3CEA1ADB013C
   *
   * @param f_moveToXPos
   * @param f_moveToYPos
   *
   * @throws xCommunication
   *
   */
  public void move(double f_moveToXPos, double f_moveToYPos) throws xCommunication;


  /**
   * This method provides the possibility to send to the server trun body command.
   *
   * @roseuid 3CEA1AE702F2
   *
   * @param f_turnAngel
   *
   * @throws xCommunication
   */
  public void turn(double f_turnAngel) throws xCommunication;


  /**
   * This method provides the possibility to send to the server say message.
   *
   * @roseuid 3CEA1B0B0240
   *
   * @param f_sayMessage
   *
   * @throws xCommunication
   */
  public void say(String f_sayMessage) throws xCommunication;


  /**
   * This method provides the option to send change view actions to the server
   * f_width has to element of: {narrow; normal; wide} and
   * f_highViewQuality has to element of: {1(->set high view quality);0 (low)}
   *
   * @param f_width
   * @param f_highViewQuality
   *
   * @throws xCommunication
   */
  public void changeView(String f_width , boolean f_highViewQuality) throws xCommunication;

}