package jais.objects;

/**
 * <p>Title: Class Angle - helper class calculating with angles</p>
 * <p>Description: this class provides some static methods that help to calculate with angles</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * @author Stephan Diederich
 */
public abstract class Angle
{
    /**
     * This method returns the normalized paramter f_angle to -180 <f_angle <180
     * @param f_angle angle to normalize
     * @return normalized angle.
     */
    public static double normalize(double f_angle)
    {
        if (f_angle>180)
            return (f_angle-=360);
        else if (f_angle<-180)
            return (f_angle+=360);
        return f_angle;
    }

    /**
     * Computes radian value of the parameter
     * @param f_angle in degree
     * @return f_angle converted to radian
     */
    public static double toRadian(double f_angle)
    {
        return (f_angle*Math.PI/180);
    }

    /**
     * Computes degree value of the given parameter
     * @param f_angle in radian
     * @return f_angle converted to degree
     */
    public static double toDegrees(double f_angle)
    {
        return (f_angle*180/Math.PI);
    }
}