package jais.objects;
import java.util.Hashtable;
import java.util.Enumeration;

/**
 *
 * <p>Title: FlagInfo is the class for storing our flags in</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p> </p>
 * @author unascribed
 *
 */
public class FlagInfo extends ObjectInfo
{
    public static Hashtable FLAG_POSITIONS = new Hashtable();
    private static boolean m_alreadySwitched=false;
    public static void initFlagPositions()
    {
      /** flags at centre of the field **/
      FLAG_POSITIONS.put("c", new Coordinate(0, 0));
      FLAG_POSITIONS.put("c b", new Coordinate(0, 34));
      FLAG_POSITIONS.put("b 0", new Coordinate(0, 39));
      FLAG_POSITIONS.put("c t", new Coordinate(0, -34));
      FLAG_POSITIONS.put("t 0", new Coordinate(0, -39));

      /** FLAG_POSITIONS to the left form bottom to the top **/
      FLAG_POSITIONS.put("b l 10", new Coordinate(-10, 39));
      FLAG_POSITIONS.put("t l 10", new Coordinate(-10, -39));
      FLAG_POSITIONS.put("b l 20", new Coordinate(-20, 39));
      FLAG_POSITIONS.put("t l 20", new Coordinate(-20, -39));
      FLAG_POSITIONS.put("b l 30", new Coordinate(-30, 39));
      FLAG_POSITIONS.put("t l 30", new Coordinate(-30, -39));
      FLAG_POSITIONS.put("p l b", new Coordinate(-36, 20));
      FLAG_POSITIONS.put("p l c", new Coordinate(-36, 0));
      FLAG_POSITIONS.put("p l t", new Coordinate(-36, -20));
      FLAG_POSITIONS.put("b l 40", new Coordinate(-40, 39));
      FLAG_POSITIONS.put("t l 40", new Coordinate(-40, -39));
      FLAG_POSITIONS.put("b l 50", new Coordinate(-50, 39));
      FLAG_POSITIONS.put("t l 50", new Coordinate(-50, -39));
      FLAG_POSITIONS.put("l b", new Coordinate(-52.5, 34));
      FLAG_POSITIONS.put("g l b", new Coordinate(-52.5, 7));
      FLAG_POSITIONS.put("g l t", new Coordinate(-52.5, -7));
      FLAG_POSITIONS.put("l t", new Coordinate(-52.5, -34));
      FLAG_POSITIONS.put("l b 30", new Coordinate(-57.5, 30));
      FLAG_POSITIONS.put("l b 20", new Coordinate(-57.5, 20));
      FLAG_POSITIONS.put("l b 10", new Coordinate(-57.5, 10));
      FLAG_POSITIONS.put("l 0", new Coordinate(-57.5, 0));
      FLAG_POSITIONS.put("l t 10", new Coordinate(-57.5, -10));
      FLAG_POSITIONS.put("l t 20", new Coordinate(-57.5, -20));
      FLAG_POSITIONS.put("l t 30", new Coordinate(-57.5, -30));

      /** FLAG_POSITIONS to the right **/
      FLAG_POSITIONS.put("b r 10", new Coordinate(10, 39));
      FLAG_POSITIONS.put("t r 10", new Coordinate(10, -39));
      FLAG_POSITIONS.put("b r 20", new Coordinate(20, 39));
      FLAG_POSITIONS.put("t r 20", new Coordinate(20, -39));
      FLAG_POSITIONS.put("b r 30", new Coordinate(30, 39));
      FLAG_POSITIONS.put("t r 30", new Coordinate(30, -39));
      FLAG_POSITIONS.put("p r b", new Coordinate(36, 20));
      FLAG_POSITIONS.put("p r c", new Coordinate(36, 0));
      FLAG_POSITIONS.put("p r t", new Coordinate(36, -20));
      FLAG_POSITIONS.put("b r 40", new Coordinate(40, 39));
      FLAG_POSITIONS.put("t r 40", new Coordinate(40, -39));
      FLAG_POSITIONS.put("b r 50", new Coordinate(50, 39));
      FLAG_POSITIONS.put("t r 50", new Coordinate(50, -39));
      FLAG_POSITIONS.put("r b", new Coordinate(52.5, 34));
      FLAG_POSITIONS.put("g r b", new Coordinate(52.5, 7));
      FLAG_POSITIONS.put("g r t", new Coordinate(52.5, -7));
      FLAG_POSITIONS.put("r t", new Coordinate(52.5, -34));
      FLAG_POSITIONS.put("r b 30", new Coordinate(57.5, 30));
      FLAG_POSITIONS.put("r b 20", new Coordinate(57.5, 20));
      FLAG_POSITIONS.put("r b 10", new Coordinate(57.5, 10));
      FLAG_POSITIONS.put("r 0", new Coordinate(57.5, 0));
      FLAG_POSITIONS.put("r t 10", new Coordinate(57.5, -10));
      FLAG_POSITIONS.put("r t 20", new Coordinate(57.5, -20));
      FLAG_POSITIONS.put("r t 30", new Coordinate(57.5, -30));
    }

   private  String m_flagType; // here will only the string be stored

   /**
    * some Access Methods
    */

   public void setFlagType(String f_flagType) {m_flagType=f_flagType;}
   public String getFlagType(){return m_flagType;}

   public Coordinate getAbsPosition()
   {
    try
    {
        Coordinate l_coord=(Coordinate) this.FLAG_POSITIONS.get(this.m_flagType);
        return (l_coord);
    }
    catch(Exception ex)
    {
        return null;
    }
   }
   /**
    * This method calculates the AbsPosition of this flag with its relative data and the Parameter f_coord
    * @param f_myAbsPosition From where the relative data should be (normally m_myWorld.getMyself().getAbsPosition())
    * @param f_myAbsViewAngle abs view angle of myself... get that from the world
    * @return The calculated AbsPosition of this flag
    */
   public Coordinate calculateAbsPosition(Coordinate f_myAbsPosition, double f_myAbsViewAngle)
   {
    double l_tempAngle = f_myAbsViewAngle+m_direction;
    l_tempAngle=Angle.normalize(l_tempAngle);
    return (new Coordinate(
                f_myAbsPosition.getX()+ Math.cos(Angle.toRadian(l_tempAngle))*this.getDistance(),
                f_myAbsPosition.getY()+ Math.sin(Angle.toRadian(l_tempAngle))*this.getDistance()
                         ));
   }
   /**
    * @roseuid 3CEB69330013
    */
   public FlagInfo()
   {
   }
}
