package jais.objects;

import java.util.Hashtable;
import java.util.Enumeration;

/**
 * <p>Title: GoalInfo</p>
 * <p>Description: This class contains methods which sets or delivers some elements of the see message</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * @author Oliver Beck, Stephan Diederich
 */
public class GoalInfo extends ObjectInfo
{

    public static Hashtable GOAL_POSITIONS = new Hashtable();
    private static boolean m_alreadySwitched=false;

    /**
     * This method initializes the goal positions
     */
    public static void initGoalPositions()
    {
        GOAL_POSITIONS.put("r", new Coordinate(52, 0));
        GOAL_POSITIONS.put("l", new Coordinate(-52, 0));
    }

    // definition of the types of goals
    public static final int GOAL_L = 0;
    public static final int GOAL_R = 1;
    public static final String [] GOAL_TYPES = {"l","r"};
    // member variables of this object, only left or right here
    private int m_goalType;


    /**
     * Access method, if it's goal left or goal right
     * @return 0 for left goal and 1 for right goal
     */
    public int getGoalType(){ return m_goalType; }

    /**
     * This method sets the goal type (left or right goal)
     * @param f_goalType contains the value of the goal type (0=left, 1=right)
     */
    public void setGoalType(int f_goalType){ m_goalType=f_goalType; }

    /**
     * Access method for absolute position of this goal in the field
     * @return absolute postion of this goal in the field
     */
    public Coordinate getAbsPosition()
    {
        return (Coordinate)GOAL_POSITIONS.get(GOAL_TYPES[m_goalType]);
    }

    /**
     * This method initializes this Object with a not existing value
     * @roseuid 3CEB693502E7
     */
    public GoalInfo()
    {
        m_goalType=-1;
    }

    /**
    * Method for switching the absolute GoalPositions
    * This is done if we play on right side
    */
   public synchronized static void switchGoalPositions()
   {
    /*this is corrected in the positioning System at the moment
    if (!m_alreadySwitched)
    {
        Coordinate l_tempCoord;
        Object l_tempKey;
        for(Enumeration e=GOAL_POSITIONS.keys();e.hasMoreElements();)
        {
            l_tempKey=e.nextElement();
            l_tempCoord=(Coordinate)GOAL_POSITIONS.get(l_tempKey);
            GOAL_POSITIONS.put(l_tempKey, (new Coordinate(-l_tempCoord.getX(), -l_tempCoord.getY())));
        }
        m_alreadySwitched=true;
    }
    */
   }
}
