package jais.objects;

/**
 * <p>Title: LineInfo</p>
 * <p>Description: This is only a data container for the answer to the init command (so members are public)</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * @author Oliver Beck, Stephan Diederich
 */
public class LineInfo extends ObjectInfo
{
    public static final int LINE_LEFT    = 0;
    public static final int LINE_RIGHT   = 1;
    public static final int LINE_TOP     = 2;
    public static final int LINE_BOTTOM  = 3;

    private int m_lineType;

    /**
     * Access method for line type
     * @return line type value: left=0, right=1, top=2, bottom=3
     */
    public int getLineType() { return m_lineType;};

    /**
     * This method sets the line type: left, right, top, bottom
     * @param f_lineType contains the line type value: left=0, right=1, top=2, bottom=3
     */
    public void setLineType(int f_lineType) { m_lineType=f_lineType;};

    /**
     * This method initializes this Object with a not existing value
     * @roseuid 3CEB693A0348
     */
    public LineInfo()
    {
     m_lineType=-1; //init this with a not existing value
    }
}
