package jais.objects;

/**
 * <p>Title: PlayerInfo</p>
 * <p>Description: This class contains methods which sets or delivers some infos of the see message</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * @author Oliver Beck, Stephan Diederich
 */

public class PlayerInfo extends ObjectInfo
{
    // these variables are set by the parser
    private boolean m_isGoalie=false;
    private double m_headFaceDir=ObjectInfo.NOT_EXISTING;
    private double m_bodyFaceDir=ObjectInfo.NOT_EXISTING;
    private String m_teamName=null;
    private int m_uniformNumber=ObjectInfo.NOT_EXISTING;

   /**
    * Access mthod for the teamname the player is member of
    * @return teamname the player is member of
    */
    public String getTeamName() {return m_teamName;}

    /**
     * Access method for the teamname the player is member of
     * @param f_teamname contains the teamname the player is member of
     */
    public void setTeamName(String f_teamName) {m_teamName=f_teamName;}

    /**
     * Access method for head face direction of the player
     * @return head face direction of the player
     */
    public double getHeadFaceDir() {return m_headFaceDir;}

    /**
     * This method sets the head face direction of the player
     * @param f_headFaceDir contains the value of the head face direction of the player
     */
    public void setHeadFaceDir(double f_headFaceDir) {m_headFaceDir=f_headFaceDir;}

    /**
     * Access method for the body face direction of the player
     * @return body face direction of the player
     */
    public double getBodyFaceDir() {return m_bodyFaceDir;}

    /**
     * This method sets the body face direction of the player
     * @param f_bodyFaceDir contains the value of the body face direction of the player
     */
    public void setBodyFaceDir(double f_bodyFaceDir) {m_bodyFaceDir=f_bodyFaceDir;}

    /**
     * This method ckecks if player is goalie or not
     * @return boolean true if player is goalie
     */
    public boolean isGoalie() {return m_isGoalie;}

    /**
     * This method sets a boolean value true if player is goalie and false if player is not goalie
     * @param f_isGoalie contains boolean true if player is goalie and false if player is not goalie
     */
    public void setGoalie(boolean f_isGoalie) {m_isGoalie=f_isGoalie;}

    /**
     * constructor only calls the main constructor, so everything from objectinfo is initialized
     * @roseuid 3CEB67A601AD
     */
    public PlayerInfo()
    {
        super();
    }

    /**
     * Access method delivers back number of the player
     * @return back number of the player
     */
    public int getBackNumber(){return m_uniformNumber;}

    /**
     * This method sets the back number of the player
     * @param f_uNum contains the number of the player
     */
    public void setBackNumber(int f_uNum){m_uniformNumber=f_uNum;}
}



