package jais.player;

import jais.objects.*;
import java.util.*;

/**
 *
 * <p>Title: Actions</p>
 * <p>Description: This class provides the different actions we can perform</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p> </p>
 * @author  Christian Traub, Stephan Diederich und Claus Kestel
 */


class Action
{
  private int m_actionType;
  private double m_actionValue1;
  private double m_actionValue2;

  /**
   *Creates a new <code>Action</code> instance.
   * @param f_actionType
   * @param f_actionValue1
   * @param f_actionValue2
   */
  public Action(int  f_actionType, double f_actionValue1, double f_actionValue2)
  {
    m_actionType = f_actionType;
    m_actionValue1 = f_actionValue1;
    m_actionValue2 = f_actionValue2;
  }


  /**
   * Returns true if a given action equals the current action
   * @param f_Type
   * @return
   */
  public boolean equals(Action f_Type)
  {
    if (m_actionType==f_Type.getActionType())
      if (Math.abs((m_actionValue1 -  f_Type.getActionValue1()))<=1)
        if (Math.abs((m_actionValue2 -  f_Type.getActionValue2()))<=1)
          return true;
    return false;
  }

  /**
   * Returns the type of an action
   * @return
   */
  public int getActionType() { return m_actionType;}

  /**
   * Get the first value of an action
   * @return
   */
  public double getActionValue1()  { return m_actionValue1; }

  /**
   * Get the second value of an action
   * @return
   */
  public double getActionValue2()  { return m_actionValue2; }
}