package jais.player;

import jais.objects.*;

/**
 *
 * <p>Title: Statemanager</p>
 * <p>Description: Stores different states over more rounds</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p> </p>
 * @author Christian Traub, Stephan Diederich und Claus Kestel
 *
 */
public class StateManager
{
  ActionManager m_my_actions;
  static final int DEFENSE = 0;
  static final int OFFENSE = 1;
  boolean m_athome=false;
  int m_state= 1;
  public static final int[] VIEW_ANGLES={45,90,180};
  public int m_currentViewWidth=1; // 0 , 1, 2
  public int m_currentViewQuality=1; // 0 for LOW, 1 for HIGH
  public boolean m_searchingBall=false;
  int m_actionCounter = 0;

  /**
   * Returns if we are offense or defense
   * @return int
   * @roseuid 3CE811C30167
   */
  public int getState()
  {
    return m_state;
  }

  /**
   * We are defense
   * @roseuid 3CE80FD80251
   */
  public void setDefensive()
  {
    m_state = DEFENSE;
  }

  /**
   * set Offense
   * @roseuid 3CE80FCB030D
   */
  public void setOffensive()
  {
    m_state = OFFENSE;
  }

  /**
   * Set if i am at my homeposition
   * @param f_atHome
   */
  public void setIAmAtHome(boolean f_atHome)
  {
    m_athome=f_atHome;
  }

  /**
   * Am I at my homeposition
   * @return
   */
  boolean amIAtHome()
  {
    return m_athome;
  }
}
