package jais.visualization;


import javax.swing.*;
import java.awt.*;
import javax.swing.border.*;

import org.apache.log4j.Logger;

/**
 *
 * <p>Title: LegendPanel class</p>
 * <p>Description: Instantiating this class effects the creation
 * of one more panel (with legends)which will be be only updated by OS</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p> </p>
 * @author Stephan Diederich (Raul Zanzinger)
 *
 */
public class LegendPanel extends JPanel
{
    //object wide variabels
    JLabel m_friendlyPlayerVisible = new JLabel();
    JLabel m_friendlyPlayerInvisible = new JLabel();
    JLabel m_enemyPlayerVisible = new JLabel();
    JLabel m_enemyPlayerInvisible = new JLabel();
    JLabel m_BallVisible = new JLabel();
    JLabel m_BallInvisible = new JLabel();
    JLabel m_FlagVisible = new JLabel();
    JLabel m_Myself = new JLabel();
    JLabel m_SeenGoal = new JLabel();
    JLabel m_SeenLine = new JLabel();
    JLabel m_visibleLabel =new JLabel();
    JLabel m_invisibleLabel = new JLabel();

    private Image m_playFieldImage;         //the second image for legend panel
    private Graphics m_g;

    static Logger logger=Logger.getLogger("jais.visualization");

    public LegendPanel()
    {
         try
        {
            jbInit();
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
        loadLegendImage();
    }

    /**
     * This method sets the attributes of the createdlegend Panel
     *
     * @throws Exception
     */
    private void jbInit() throws Exception
    {
        m_friendlyPlayerVisible.setText("Friendly Player");
        m_friendlyPlayerVisible.setForeground(PlayFieldPanel.COLOR_FRIENDLY_PLAYER_VISIBLE);
        m_friendlyPlayerInvisible.setText("Friendly Player");
        m_friendlyPlayerInvisible.setForeground(PlayFieldPanel.COLOR_FRIENDLY_PLAYER_INVISIBLE);
        m_enemyPlayerVisible.setText("Enemy Player");
        m_enemyPlayerVisible.setForeground(PlayFieldPanel.COLOR_ENEMY_PLAYER_VISIBLE);
        m_enemyPlayerInvisible.setText("Enemy Player");
        m_enemyPlayerInvisible.setForeground(PlayFieldPanel.COLOR_ENEMY_PLAYER_INVISIBLE);
        m_BallVisible.setText("Ball");
        m_BallVisible.setForeground(PlayFieldPanel.COLOR_BALL_VISIBLE);
        m_BallInvisible.setText("Ball");
        m_BallInvisible.setForeground(PlayFieldPanel.COLOR_BALL_INVISIBLE);
        m_FlagVisible.setText("Flag");
        m_FlagVisible.setForeground(PlayFieldPanel.COLOR_FLAG_VISIBLE);
        m_Myself.setText("Myself");
        m_Myself.setForeground(PlayFieldPanel.COLOR_MYSELF);
        m_SeenGoal.setText("Seen Goal");
        m_SeenGoal.setForeground(PlayFieldPanel.COLOR_SEEN_GOAL);
        m_SeenLine.setText("Seen Line");
        m_SeenLine.setForeground(PlayFieldPanel.COLOR_SEEN_LINE);
        m_visibleLabel.setFont(new java.awt.Font("Dialog", 1, 16));
        m_visibleLabel.setText("\"Visible\"");
        m_invisibleLabel.setFont(new java.awt.Font("Dialog", 1, 16));
        m_invisibleLabel.setText("\"Invisible\"");
        this.setLayout(new FlowLayout(FlowLayout.CENTER,30,5));
        this.setBackground(SystemColor.inactiveCaption);
        this.setBorder(new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(165, 163, 151)));
        this.setMaximumSize(new Dimension(100, 400));
        this.setMinimumSize(new Dimension(100, 400));
        this.setPreferredSize(new Dimension(100, 400));
        this.add(m_visibleLabel);
        this.add(m_friendlyPlayerVisible);
        this.add(m_enemyPlayerVisible);
        this.add(m_BallVisible);
        this.add(m_FlagVisible);
        this.add(m_Myself);
        this.add(m_SeenGoal);
        this.add(m_SeenLine);
        this.add(m_invisibleLabel);
        this.add(m_friendlyPlayerInvisible);
        this.add(m_enemyPlayerInvisible);
        this.add(m_BallInvisible);
     }


    /**
     *
     */
    private void loadLegendImage()
    {
        m_playFieldImage = getToolkit().getImage("../ext/LegendPanel.jpg");
        MediaTracker l_imageWatcher = new MediaTracker(this);
        //fetch image from file and set it's ID on 0
        l_imageWatcher.addImage(m_playFieldImage, 0);
        try
        {
              //wait till the play field image is completely loaded
              logger.info("Waiting for image been loaded!");
              l_imageWatcher.waitForAll();
              logger.info("Play field image has been loaded!");
         }
         catch (InterruptedException e)
         {
               logger.info("Error loading image from file!");
         }
    }


     /**
      *
      * @param f_g
      */
     public void paintComponent(Graphics f_g)
     {
        f_g.drawImage(m_playFieldImage,0,0,(int)this.getSize().getWidth(),(int)this.getSize().getHeight(),this);
     }
}