package jais.visualization;

import javax.swing.*;
import org.apache.log4j.Logger;
import jais.world.WorldModel;
import java.awt.*;


/**
 *
 * <p>Title: Main frame class</p>
 * <p>Description: Instantiating this class creats a new window</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p> </p>
 * @author Stephan Diederich, Raul Zanzinger
 *
 */
class MainFrame extends JFrame
{
  static Logger logger=Logger.getLogger("jais.visualization");
  JPanel m_playfield;
  JPanel m_legend;

  public MainFrame(WorldModel f_myWorld,String f_teamName, int f_playerNumber)
  {
    super("Visualization of player with back#: "+f_playerNumber+", Team: "+f_teamName);
    // set title of the window which will created
    // set size of created window
    setSize(700, 400);
    setResizable(true);
    // replace content pane with new playfield component
    m_legend=new LegendPanel();
    m_playfield=new PlayFieldPanel(f_myWorld);
    this.getContentPane().setLayout(new BorderLayout());
    this.getContentPane().add(m_playfield,BorderLayout.CENTER);
    this.getContentPane().add(m_legend,BorderLayout.EAST);
    // show window
    setVisible(true);
    this.toFront();
  }

  /**
   * This method is used by OS for every done refresh
   *
   */
  public void repaintPlayfield()
  {
    m_playfield.repaint();
  }
}