package jais.world;

/**
 * <p>Title: WorldActionInformInterface</p>
 * <p>Description: This interface provides the possibility for the KI to inform the WorldModel about actions which are performed. It has to be implemented in future.</p>
 * <p>Copyright: (c) 2002</p>
 * @author Stephan Diederich, Florian Mnz
 **/
public interface WorldActionInformInterface
{
  /**
   * this method should inform the world about a catchBall action send to the server from the KI
   * @param f_angle
   */
  public void informCatchBall(double f_angle);

  /**
   * this method should inform the world about a dash action send to the server from the KI
   * @param f_power
   */
  public void informDash(double f_power);

  /**
   * this method should inform the world about a kick action send to the server from the KI
   * @param f_power
   * @param f_angle
   */
  public void informKick(double f_power, double f_angle);

  /**
   * this method should inform the world about a turnNeck action send to the server from the KI
   * @param f_angle
   */
  public void informTurnNeck(double f_angle);

  /**
   * this method should inform the world about a move action send to the server from the KI
   * @param f_x
   * @param f_y
   */
  public void informMove(double f_x, double f_y);

  /**
   * this method should inform the world about a turn action send to the server from the KI
   * @param f_angle
   */
  public void informTurn(double f_angle);
}