package jais.world;

import jais.communication.*;

/**
 * <p>Title: WorldDataAccessInterface</p>
 * <p>Description: This interface defines how the WorldModel can be updated with new information.</p>
 * <p>Copyright: (c) 2002</p>
 * @author Stephan Diederich, Florian Mnz
 **/
public interface WorldUpdateInterface
{
  /**
   * determs the type of sender and stores the AurealInfo in the corresponding list
   * @param f_hearEvent hghg
   * @roseuid 3CE8BB580190
   */
  public void updateAurealInfo(HearEvent f_hearEvent);

  /**
   * determs the type of object and stores the VisualInfo in the corresponding list
   * @param f_visualEvent
   * @roseuid 3CE8BB6E020A
   */
  public void updateVisualInfo(VisualEvent f_visualEvent);

  /**
   * stores the SenseBodyInfo in the corresponding list
   * @param f_senseBodyEvent
   * @roseuid 3CE8BB8401D0
   */
  public void updateSenseBodyInfo(SenseBodyEvent f_senseBodyEvent);

  /**
   * initialized playingside, backnumber and playmode
   * @param f_InitialEvent
   */
  public void updateInitInfo(InitialEvent f_InitialEvent);
}